#define MAX_GRAMMAR 432
#define PHRASE_BASE 515
int gram[MAX_GRAMMAR] = {
    1,     2,   516,   520,     6,     2,   522,   516,     2,   518,   516,     2,   534,   516,     2,   532, 
  516,     2,   529,   516,     0,     4,     2,   522,   516,     2,   532,   516,     2,   529,   516,     0, 
    1,     9,   256,   527,    40,   530,    41,   517,   520,   257,   548,    10,     5,   527,    61,   542, 
  541,   548,     8,   527,    91,   551,    93,    61,   542,   541,   548,     3,   540,   541,   548,     2, 
  537,   548,     2,   539,   548,     8,   258,    40,   542,    41,   259,   520,   260,   548,     4,   261, 
  520,   262,   548,     4,   263,   542,   541,   548,     3,   263,   541,   548,     4,   264,   527,   541, 
  548,     2,     3,   524,   519,   520,     0,     1,     5,   265,   527,    61,   572,   548,     1,     4, 
  266,   523,   531,   548,     2,     3,   512,    61,   542,     1,   512,     2,     2,   525,   524,     0, 
    1,     2,   527,    58,     1,     0,     1,     1,   512,     1,     1,   512,     1,     3,   267,   527, 
  548,     2,     2,   527,   530,     0,     2,     3,    44,   523,   531,     0,     2,     9,   265,   268, 
  527,    91,   513,    93,    61,   533,   548,     6,   268,   512,    91,   513,    93,   548,     2,     2, 
  513,   533,     0,     1,     8,   269,   527,    40,   535,    41,    61,   542,   548,     1,     2,   527, 
  536,     2,     3,    44,   527,   536,     0,     1,     6,   270,   542,   548,   520,   538,   271,     4, 
    6,   272,   270,   542,   548,   520,   538,     5,   273,   542,   548,   520,   538,     3,   272,   548, 
  520,     0,     1,     5,   274,   548,   520,   275,   541,     1,     4,   527,    40,   570,    41,     2, 
    2,   270,   542,     0,     1,     2,   544,   543,     2,     3,   564,   544,   543,     0,     1,     2, 
  546,   545,     2,     3,   565,   546,   545,     0,     1,     2,   547,   549,     2,     1,    33,     0, 
    2,     1,    59,     0,     1,     2,   551,   550,     2,     2,   566,   551,     0,     1,     2,   553, 
  552,     2,     3,   567,   553,   552,     0,     1,     3,   555,   559,   558,     3,     1,    43,     1, 
   45,     2,    92,    92,     2,     1,   554,     0,     2,     1,    43,     1,    45,     2,     1,   556, 
    0,     2,     3,   556,   559,   558,     0,     1,     2,   561,   560,     2,     3,   568,   561,   560, 
    0,     1,     2,   569,   562,     2,     3,   563,   569,   562,     0,     1,     1,    38,     1,     2, 
  124,   124,     1,     2,    38,    38,     9,     2,    60,    62,     2,    60,    61,     1,    60,     2, 
   62,    61,     1,    62,     2,    33,    61,     2,    61,    61,     1,    35,     1,    61,     2,     2, 
   60,    60,     2,    62,    62,     2,     1,    42,     1,    47,     5,     3,    40,   542,    41,     4, 
  527,    40,   570,    41,     4,   527,    91,   551,    93,     1,   527,     1,   572,     2,     2,   551, 
  571,     0,     2,     3,    44,   551,   571,     0,     3,     1,   513,     2,   554,   513,     1,   514, 
};

#define MAX_KEYWORD 20
char *keyword[MAX_KEYWORD] = { // Keywords are based at 256
  "proc", "end", "while", "do", 
  "endwhile", "loop", "endloop", "return", 
  "jump", "const", "var", "extern", 
  "array", "let", "if", "finish", 
  "else", "elseif", "cycle", "repeat", 
  };

#define MAX_BIP 3
int BIP[MAX_BIP] = { // BIPs precede PHRASEs at 512 upwards
 1,  5,  3, 
};

#define MAX_PHRASE 61
#ifdef DEBUG_PARSER
// FOR DEBUGGING ONLY
char *phrasename[MAX_PHRASE] = { // Based at 512 upwards
  "IDENT", "NUM", "CHARLIT", "PROGRAM", 
  "DECLARATIONS", "PROCDECLARATIONS", "PROCDECL", "SS", 
  "SSLIST", "CONSTDECL", "VARDECL", "VARDEC", 
  "OPTLABELS", "LABEL", "SYNTAXERROR", "EXISTINGVAR", 
  "NEWVAR", "EXTERN", "ARGLIST", "VARDECLIST", 
  "ARRAY", "INITLIST", "DEFFN", "FORMALS", 
  "RESTOFFORMALS", "IFSEQ", "OPTELSEPART", "LOOP", 
  "PROCCALL", "OPTIF", "BOOLEXPR", "RESTOFBOOLTERM", 
  "BOOLTERM", "RESTOFBOOLFACTOR", "BOOLFACTOR", "OPTNOT", 
  "OPTSEMI", "RELATION", "RESTOFRELATION", "EXPR", 
  "RESTOFEXPR", "SUM", "UNOP", "OPTUNOP", 
  "ADDOP", "OPTADDOP", "RESTOFSUM", "TERM", 
  "RESTOFTERM", "BITFACTOR", "RESTOFBITFACTOR", "BITOP", 
  "BOROP", "BANDOP", "RELOP", "SHIFTOP", 
  "MULOP", "FACTOR", "PARAMLIST", "RESTOFPARAMLIST", 
  "NUMBER", 
};
#endif /* DEBUG_PARSER */

int phrase_start[MAX_PHRASE-MAX_BIP] = {
    0,     4,    21,    32,    43,    97,   103,   110,   116,   123,   128,   132,   134, 
  137,   140,   145,   150,   156,   174,   179,   189,   193,   199,   207,   226,   233,   239,   244,   248, 
  254,   258,   264,   268,   272,   276,   280,   285,   289,   295,   300,   308,   312,   317,   321,   327, 
  331,   337,   341,   347,   350,   354,   358,   382,   389,   394,   413,   418,   424, 
};

#define P_IDENT 512
#define P_NUM 513
#define P_CHARLIT 514
#define P_PROGRAM 515
#define P_DECLARATIONS 516
#define P_PROCDECLARATIONS 517
#define P_PROCDECL 518
#define P_SS 519
#define P_SSLIST 520
#define P_CONSTDECL 521
#define P_VARDECL 522
#define P_VARDEC 523
#define P_OPTLABELS 524
#define P_LABEL 525
#define P_SYNTAXERROR 526
#define P_EXISTINGVAR 527
#define P_NEWVAR 528
#define P_EXTERN 529
#define P_ARGLIST 530
#define P_VARDECLIST 531
#define P_ARRAY 532
#define P_INITLIST 533
#define P_DEFFN 534
#define P_FORMALS 535
#define P_RESTOFFORMALS 536
#define P_IFSEQ 537
#define P_OPTELSEPART 538
#define P_LOOP 539
#define P_PROCCALL 540
#define P_OPTIF 541
#define P_BOOLEXPR 542
#define P_RESTOFBOOLTERM 543
#define P_BOOLTERM 544
#define P_RESTOFBOOLFACTOR 545
#define P_BOOLFACTOR 546
#define P_OPTNOT 547
#define P_OPTSEMI 548
#define P_RELATION 549
#define P_RESTOFRELATION 550
#define P_EXPR 551
#define P_RESTOFEXPR 552
#define P_SUM 553
#define P_UNOP 554
#define P_OPTUNOP 555
#define P_ADDOP 556
#define P_OPTADDOP 557
#define P_RESTOFSUM 558
#define P_TERM 559
#define P_RESTOFTERM 560
#define P_BITFACTOR 561
#define P_RESTOFBITFACTOR 562
#define P_BITOP 563
#define P_BOROP 564
#define P_BANDOP 565
#define P_RELOP 566
#define P_SHIFTOP 567
#define P_MULOP 568
#define P_FACTOR 569
#define P_PARAMLIST 570
#define P_RESTOFPARAMLIST 571
#define P_NUMBER 572
