# BIPS (Built-in Phrases) are linked to the type-code returned
# by the line-reconstruction code (aka lexer)

# These *must* come first.

B<IDENT>=1;
B<NUM>=5;
B<CHARLIT>=3;

# Phrase definitions.  SSLIST is the main entry point.


P<SSLIST> = <STATEMENT> <SSLIST>,
            ;

P<STATEMENT> = <SIMPLE> <OPTSEMI>;

P<SIMPLE> = <SS>,
            <CONSTDECL>,
            <VARDECL>,
            <DEFFN>;

P<CONSTDECL> = "const" <IDENT> '=' <NUM>;

P<VARDECL> = "word" <IDENT>;

P<DEFFN> = "let" <IDENT> '(' <FORMALS> ')' '=' <BOOLEXPR>;

P<FORMALS> = <IDENT> <RESTOFFORMALS>;

P<RESTOFFORMALS> = ',' <IDENT> <RESTOFFORMALS>, ;

P<SS> = <IDENT> '=' <BOOLEXPR>;

P<BOOLEXPR> = <BOOLTERM> <RESTOFBOOLTERM>;

P<RESTOFBOOLTERM> = <OROP> <BOOLTERM> <RESTOFBOOLTERM>,
                    ;

P<BOOLTERM> = <BOOLFACTOR> <RESTOFBOOLFACTOR>;

P<RESTOFBOOLFACTOR> = <ANDOP> <BOOLFACTOR> <RESTOFBOOLFACTOR>,
                      ;

P<BOOLFACTOR> = <OPTNOT> <RELATION>;

P<OPTNOT> = '!',
            ;

P<OPTSEMI> = ';',
             ;

P<RELATION> = <EXPR> <RESTOFRELATION>;

P<RESTOFRELATION> = <RELOP> <EXPR>,
                    ;

P<EXPR> = <SUM> <RESTOFEXPR>;

P<RESTOFEXPR> = <SHIFTOP> <SUM> <RESTOFEXPR>,
                ;

P<SUM> = <OPTADDOP> <TERM> <RESTOFSUM>;

P<OPTADDOP> = <ADDOP>,
              ;

P<RESTOFSUM> = <ADDOP> <TERM> <RESTOFSUM>,
               ;

P<TERM> = <FACTOR> <RESTOFTERM>;

P<RESTOFTERM> = <MULOP> <FACTOR> <RESTOFTERM>,
                ;

P<OROP> = '||';

P<ANDOP> = '&&';

P<RELOP> = '<>', '<=', '<', '>=', '>', '!=', '=';

P<SHIFTOP> = '<<', '>>';

P<ADDOP> = '+', '-';

P<MULOP> = '*', '/';

P<FACTOR> = '(' <BOOLEXPR> ')',
            <IDENT> '(' <PARAMLIST> ')',
            <IDENT>,
            <NUMBER>;

 P<PARAMLIST> = <EXPR> <RESTOFPARAMLIST>,
              ;


 P<RESTOFPARAMLIST> = ',' <EXPR> <RESTOFPARAMLIST>,
               ;


P<NUMBER> = <NUM>,
            <CHARLIT>;

E
# 'E' is end of grammar.  Everything after this is ignored.
